var $iA2ta$reactjsxruntime = require("react/jsx-runtime");
var $iA2ta$react = require("react");

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}

$parcel$export(module.exports, "createAPIs", () => $9233cea927cb9637$export$1f41eb08414e9201);


const $9233cea927cb9637$var$isObj = (obj)=>typeof obj === "object" && obj !== null && !Array.isArray(obj);
function $9233cea927cb9637$var$deepMerge(obj1, obj2) {
    if (obj2 === undefined) return obj1;
    if (!$9233cea927cb9637$var$isObj(obj1) || !$9233cea927cb9637$var$isObj(obj2)) return obj2;
    const obj = {
        ...obj1
    };
    for (const [key, value] of Object.entries(obj2))obj[key] = $9233cea927cb9637$var$deepMerge(obj[key], value);
    return obj;
}
function $9233cea927cb9637$var$useValueRef(value) {
    const ref = (0, $iA2ta$react.useRef)(value);
    if (ref.current !== value) ref.current = value;
    return ref;
}
function $9233cea927cb9637$var$useMemoValue(value) {
    const ref = (0, $iA2ta$react.useRef)(value);
    return (0, $iA2ta$react.useMemo)(()=>{
        if (JSON.stringify(value) !== JSON.stringify(ref.current)) ref.current = value;
        return ref.current;
    }, [
        value
    ]);
}
function $9233cea927cb9637$var$createProvider(ctx) {
    return function Provider({ config: config , children: children  }) {
        return /*#__PURE__*/ (0, $iA2ta$reactjsxruntime.jsx)(ctx.Provider, {
            value: config,
            children: children
        });
    };
}
function $9233cea927cb9637$var$reducer(state, action) {
    return {
        ...state,
        ...action
    };
}
const $9233cea927cb9637$var$defaultResult = {
    loading: false,
    data: undefined,
    error: undefined
};
function $9233cea927cb9637$var$createUseLazyApi(ctx, apis) {
    return function useLazyApi(key, defaultOpts = {}) {
        const defaultOptsRef = $9233cea927cb9637$var$useValueRef(defaultOpts);
        const api = apis[key];
        const { fetcher: fetcher  } = (0, $iA2ta$react.useContext)(ctx);
        const [result, setResult] = (0, $iA2ta$react.useReducer)($9233cea927cb9637$var$reducer, $9233cea927cb9637$var$defaultResult);
        const fetch = (0, $iA2ta$react.useCallback)(async (opts = {})=>{
            const { onFetch: onFetch , onCompleted: onCompleted , variables: variables = {}  } = $9233cea927cb9637$var$deepMerge(defaultOptsRef.current, opts);
            if (onFetch) onFetch();
            setResult({
                loading: true
            });
            let data = null, error = null;
            try {
                data = await fetcher(api, variables);
            } catch (err) {
                error = err;
            }
            setResult({
                loading: false,
                data: data,
                error: error
            });
            if (onCompleted) onCompleted({
                data: data,
                error: error
            });
            return {
                data: data,
                error: error
            };
        }, [
            fetcher,
            api,
            setResult
        ]);
        return [
            fetch,
            {
                ...result,
                refetch: fetch
            }
        ];
    };
}
function $9233cea927cb9637$var$createUseMutationApi(ctx, apis) {
    const useLazyApi = $9233cea927cb9637$var$createUseLazyApi(ctx, apis);
    return function useMutationApi(key, opts = {}) {
        return useLazyApi(key, opts);
    };
}
function $9233cea927cb9637$var$createUseApi(ctx, apis) {
    const useLazyApi = $9233cea927cb9637$var$createUseLazyApi(ctx, apis);
    return function useApi(key, opts = {}) {
        const [loading, setLoading] = (0, $iA2ta$react.useReducer)((_, s)=>s, false);
        const onFetch = (0, $iA2ta$react.useCallback)(()=>setLoading(true), []);
        const onCompleted = (0, $iA2ta$react.useCallback)(()=>setLoading(false), []);
        const [fetch, result] = useLazyApi(key, {
            ...opts,
            onFetch: onFetch,
            onCompleted: onCompleted
        });
        const latestVariables = $9233cea927cb9637$var$useMemoValue(opts.variables);
        (0, $iA2ta$react.useEffect)(()=>{
            fetch();
        }, [
            fetch,
            latestVariables
        ]);
        return {
            ...result,
            loading: loading
        };
    };
}
const $9233cea927cb9637$var$missingFetcher = async ()=>{
    throw new Error("Missing fetcher!");
};
function $9233cea927cb9637$export$1f41eb08414e9201(apis) {
    const ctx = /*#__PURE__*/ (0, $iA2ta$react.createContext)({
        fetcher: $9233cea927cb9637$var$missingFetcher
    });
    return {
        Provider: $9233cea927cb9637$var$createProvider(ctx),
        useLazyApi: $9233cea927cb9637$var$createUseLazyApi(ctx, apis),
        useMutationApi: $9233cea927cb9637$var$createUseMutationApi(ctx, apis),
        useApi: $9233cea927cb9637$var$createUseApi(ctx, apis)
    };
}


//# sourceMappingURL=main.js.map
