export type ApiVariables<T extends Partial<Record<'body' | 'query' | 'body', any>> = {}> = T;
interface ApiConfig<APIs> {
    fetcher: <T>(api: APIs[keyof APIs], variables: ApiVariables) => Promise<T>;
}
type ApiProviderProps<T> = React.PropsWithChildren<{
    config: ApiConfig<T>;
}>;
interface UseLazyApiOptions<TData, TError, TVariables> {
    variables?: TVariables;
    onFetch?: () => void;
    onCompleted?: (params: {
        data: TData | null;
        error: TError | null;
    }) => void;
}
export function createAPIs<T, TData extends Record<keyof T, any> = any, TError extends Record<keyof T, any> = any, TVariables extends Record<keyof T, any> = any>(apis: T): {
    Provider: ({ config, children }: ApiProviderProps<T>) => JSX.Element;
    useLazyApi: <K extends keyof T, TApiData extends TData[K], TApiError extends TError[K], TApiVariables extends TVariables[K]>(key: K, defaultOpts?: UseLazyApiOptions<TApiData, TApiError, TApiVariables>) => readonly [(opts?: Pick<UseLazyApiOptions<TApiData, TApiError, TApiVariables>, "variables">) => Promise<{
        data: TApiData | null;
        error: TApiError | null;
    }>, {
        readonly refetch: (opts?: Pick<UseLazyApiOptions<TApiData, TApiError, TApiVariables>, "variables">) => Promise<{
            data: TApiData | null;
            error: TApiError | null;
        }>;
        readonly loading: boolean;
        readonly data: TApiData | null | undefined;
        readonly error: TApiError | null | undefined;
    }];
    useMutationApi: <K_1 extends keyof T, TApiData_1 extends TData[K_1], TApiError_1 extends TError[K_1], TApiVariables_1 extends TVariables[K_1]>(key: K_1, opts?: UseLazyApiOptions<TApiData_1, TApiError_1, TApiVariables_1>) => readonly [(opts?: Pick<UseLazyApiOptions<TApiData_1, TApiError_1, TApiVariables_1>, "variables">) => Promise<{
        data: TApiData_1 | null;
        error: TApiError_1 | null;
    }>, {
        readonly refetch: (opts?: Pick<UseLazyApiOptions<TApiData_1, TApiError_1, TApiVariables_1>, "variables">) => Promise<{
            data: TApiData_1 | null;
            error: TApiError_1 | null;
        }>;
        readonly loading: boolean;
        readonly data: TApiData_1 | null | undefined;
        readonly error: TApiError_1 | null | undefined;
    }];
    useApi: <K_2 extends keyof T, TApiData_2 extends TData[K_2], TApiError_2 extends TError[K_2], TApiVariables_2 extends TVariables[K_2]>(key: K_2, opts?: UseLazyApiOptions<TApiData_2, TApiError_2, TApiVariables_2>) => {
        loading: boolean;
        refetch: (opts?: Pick<UseLazyApiOptions<TApiData_2, TApiError_2, TApiVariables_2>, "variables">) => Promise<{
            data: TApiData_2 | null;
            error: TApiError_2 | null;
        }>;
        data: TApiData_2 | null | undefined;
        error: TApiError_2 | null | undefined;
    };
};

//# sourceMappingURL=types.d.ts.map
